$AsciiMap = "\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0A\x0B\x0C\x0D\x0E\x0F"@
	"\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1A\x1B\x1C\x1D\x1E\x1F"@
	"\x20\x21\x22\x23\x24\x25\x26\x27\x28\x29\x2A\x2B\x2C\x2D\x2E\x2F"@
	"\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\x3A\x3B\x3C\x3D\x3E\x3F"@
	"\x40\x41\x42\x43\x44\x45\x46\x47\x48\x49\x4A\x4B\x4C\x4D\x4E\x4F"@
	"\x50\x51\x52\x53\x54\x55\x56\x57\x58\x59\x5A\x5B\x5C\x5D\x5E\x5F"@
	"\x60\x61\x62\x63\x64\x65\x66\x67\x68\x69\x6A\x6B\x6C\x6D\x6E\x6F"@
	"\x70\x71\x72\x73\x74\x75\x76\x77\x78\x79\x7A\x7B\x7C\x7D\x7E\x7F"@
	"\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F"@
	"\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F"@
	"\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF"@
	"\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF"@
	"\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF"@
	"\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF"@
	"\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF"@
	"\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF";

package Brainfuck
{
	function servercmdMessageSent(%cl, %msg)
	{
		if(getWord(%msg, 0) $= "@bf")
		{
			%word = getWord(%msg, 1);
			if(%word $= "start")
			{
				%cl.chatMessage("<color:FFFFFF>Receiving Brainfuck code...");
				%cl.writingBF = 1;
				%cl.bfCfgInput = 0;
				%cl.bfCfgOutput = 0;
				%cl.bfCode = "";
			}
			else if(%word $= "end")
			{
				if(!%cl.writingBF)
					return;
				%cl.writingBF = 0;
				%code = stripNonBrainfuck(%cl.bfCode);
				if(%code $= "")
				{
					%cl.chatMessage("<color:FFFFFF>Brainfuck code cancelled.");
					return;
				}
				if(getSubStr(%code, 65536, 1) !$= "")
				{
					%cl.chatMessage("<color:FFFFFF>Brainfuck code too long (>65536 chars)!");
					return;
				}
				%cl.chatMessage("<color:FFFFFF>Brainfuck code received!");
				if(isObject(%set = BrainfuckSet))
				{
					%count = %set.getCount();
					for(%i=0;%i<%count;%i++)
						if((%obj = %set.getObject(%i)).owner == %cl)
							%obj.delete();
				}
				initBrainfuck(%code, %cl);
			}
			else if(%word $= "cfg")
			{
				if(!%cl.writingBF)
					return;
				%word = getWord(%msg, 2);
				if(%word $= "in")
				{
					%word = getWord(%msg, 3);
					if(%word $= "lchat")
						%cl.bfCfgInput = 0;
					else if(%word $= "gchat")
						%cl.bfCfgInput = 1;
					else
					{
						%cl.chatMessage("\c6Valid in values:");
						%cl.chatMessage("\c6lchat = your chat only.");
						%cl.chatMessage("\c6gchat = server chat.");
					}
				}
				else if(%word $= "out")
				{
					%word = getWord(%msg, 3);
					if(%word $= "lchat")
						%cl.bfCfgOutput = 0;
					else if(%word $= "gchat")
						%cl.bfCfgOutput = 1;
					else if(%word $= "lcmd")
						%cl.bfCfgOutput = 2;
					else if(%word $= "gcmd")
						%cl.bfCfgOutput = 3;
					else
					{
						%cl.chatMessage("\c6Valid out values:");
						%cl.chatMessage("\c6lchat = your chat only.");
						%cl.chatMessage("\c6gchat = server chat under your name.");
						%cl.chatMessage("\c6lcmd = your chat only, or a command by you if output starts with /.");
						%cl.chatMessage("\c6gcmd = server chat under your name, or a command by you if output starts with /.");
					}
				}
				else
				{
					%cl.chatMessage("\c6Valid cfg settings:");
					%cl.chatMessage("\c6in = input channel for the program.");
					%cl.chatMessage("\c6out = output channel for the program.");
				}
			}
			else
			{
				%cl.chatMessage("\c6Valid @bf commands:");
				%cl.chatMessage("\c6start = start listening for brainfuck input.");
				%cl.chatMessage("\c6cfg = change a config setting for the current brainfuck program.");
				%cl.chatMessage("\c6end = finish and run the current brainfuck program.");
			}
		}
		else if(%cl.writingBF)
			%cl.bfCode = %cl.bfCode @ %msg;
		else
		{
			if(isObject(%set = BrainfuckSet))
			{
				%count = %set.getCount();
				for(%i=0;%i<%count;%i++)
					if((%obj = %set.getObject(%i)).getInput && (%obj.owner == %cl || (%obj.inputMode & 1)))
						%obj.input = %obj.input @ ((%obj.inputMode & 1) ? %cl.name @ ": " : "") @ %msg @ "\r\n";
			}
			Parent::servercmdMessageSent(%cl, %msg);
		}
	}
};
activatePackage("Brainfuck");

function stripNonBrainfuck(%code)
{
	%len = strLen(%code);
	%valid = "[]<>+-.,";
	for(%i=0;%i<%len;%i++)
	{
		%char = getSubStr(%code, %i, 1);
		if((%pos = strPos(%valid, %char)) == -1)
			continue;
		%out = %out @ %char;
	}
	return %out;
}

function validateBrainfuck(%code)
{
	%len = strLen(%code);
	%valid = "[]<>+-.,";
	for(%i=0;%i<%len;%i++)
	{
		%char = getSubStr(%code, %i, 1);
		if((%pos = strPos(%valid, %char)) == -1)
			return 0;
		if(%pos == !!%pos)
			%pairs += %pos ? -1 : 1;
	}
	return %pairs == 0;
}

function initBrainfuck(%code, %cl)
{
	if(!validateBrainfuck(%code))
		return;
	%mem = new ScriptObject() { owner = %cl; };
	if(!isObject(BrainfuckSet))
		new SimSet(BrainfuckSet);
	BrainfuckSet.add(%mem);
	%mem.inputMode = %cl.bfCfgInput;
	%mem.outputMode = %cl.bfCfgOutput;
	runBrainfuck(%mem, %code, 0, 0);
}

function runBrainfuck(%mem, %code, %oper, %ptr)
{
	if(!isObject(%mem))
		return;
	for(%i=0;%i<1024;%i++)
	{
		%char = getSubStr(%code, %oper, 1);
		switch$(%char)
		{
			case ">": %ptr = (%ptr + 1) & 1048575;
			case "<": %ptr = (%ptr - 1) & 1048575;
			case "+": %mem.byte[%ptr] = (%mem.byte[%ptr] + 1) & 255;
			case "-": %mem.byte[%ptr] = (%mem.byte[%ptr] - 1) & 255;
			case ".":
				//echo("emitting "@%mem.byte[%ptr]@" char...");
				if(%mem.byte[%ptr] == 0
					|| %mem.byte[%ptr] == 10
					|| %mem.byte[%ptr] == 13)
				{
					if(%mem.output !$= "")
					{
						if((%mem.outputMode & 2) && getSubStr(trim(%mem.output), 0, 1) $= "/")
						{
							%mem.output = trim(%mem.output);
							%mem.output = getSubStr(%mem.output, 1, strLen(%mem.output) - 1);
							if(isFunction(%func = firstWord(%mem.output)))
							{
								for(%i=0;%i<20;%i++)
									%v[%i] = getWord(%mem.output, %i + 1);
								%mem.output = "";
								call(%func, %mem.owner, %v0, %v1, %v2, %v3, %v4, %v5, %v6, %v7, %v9,
									%v10, %v11, %v12, %v13, %v14, %v15, %v16, %v17, %v18, %v19);
							}
						}
						else
						{
							if(%mem.outputMode & 1)
								servercmdMessageSent(%mem.owner, %mem.output);
							else %mem.owner.chatMessage(strReplace(%mem.output, "%", "%%"));
						}
					}
					%mem.output = "";
				}
				else %mem.output = %mem.output @ getSubStr($AsciiMap, %mem.byte[%ptr] - 1, 1);
			case ",":
				if((%len = strLen(%mem.input)) == 0)
				{
					%mem.getInput = 1;
					schedule(16, 0, "runBrainfuck", %mem, %code, %oper, %ptr);
					return 0;
				}
				else
				{
					%inChar = getSubStr(%mem.input, 0, 1);
					%mem.input = getSubStr(%mem.input, 1, %len - 1);
					%mem.byte[%ptr] = strPos($AsciiMap, %inChar) + 1;
				}
			case "[":
				if(!%mem.byte[%ptr])
				{
					if(%mem.jump[%oper] !$= "")
						%oper = %mem.jump;
					else
					{
						%depth = 1;
						%next = %oper;
						while(%depth)
						{
							%next = getMinPos(strPos(%code, "[", %next + 1), strPos(%code, "]", %next + 1));
							%depth += getSubStr(%code, %next, 1) $= "[" ? 1 : -1;
						}
						%mem.jump[%oper] = %next;
						%oper = %next;
					}
				}
			case "]":
				if(%mem.byte[%ptr])
				{
					if(%mem.jump[%oper] !$= "")
						%oper = %mem.jump;
					else
					{
						%depth = 1;
						%prev = %oper;
						while(%depth)
						{
							%prev = getMax(lStrPos(%code, "[", %prev - 1), lStrPos(%code, "]", %prev - 1));
							%depth += getSubStr(%code, %prev, 1) $= "]" ? 1 : -1;
						}
						%mem.jump[%oper] = %prev;
						%oper = %prev;
					}
				}
			default:
				if(%mem.output !$= "")
					%mem.owner.chatMessage(%mem.output);
				%mem.delete();
				return 0;
		}
		%oper++;
	}
	schedule(16, 0, "runBrainfuck", %mem, %code, %oper, %ptr);
	return 0;
}

function getMinPos(%a, %b)
{ return %a < %b && %a != -1 || %b == -1 ? %a : %b; }

function lStrPos(%hay, %needle, %offset)
{
	if(%offset $= "" || %offset < 0)
		%offset = strLen(%hay) - 1;
	%len = strLen(%needle);
	while(%offset >= 0)
	{
		if(strCmp(getSubStr(%hay, %offset, %len), %needle) == 0)
			return %offset;
		%offset--;
	}
	return %offset;
}

function lStriPos(%hay, %needle, %offset)
{
	if(%offset $= "")
		%offset = strLen(%hay) - 1;
	%len = strLen(%needle);
	while(%offset >= 0)
	{
		if(getSubStr(%hay, %offset, %len) $= %needle)
			return %offset;
		%offset--;
	}
	return %offset;
}